PRECISIONS = ['002', '005', '010', '040', '150', '999']

BASE_OBJECT_SCHEMA = {
    'gmlid': {'required': True, 'type': 'string', 'empty': False},
    'idobjet': {'required': True, 'type': 'string', 'empty': False},
    'precisionp': {'required': True, 'type': 'string', 'allowed': PRECISIONS},
    'precisiona': {'required': True, 'type': 'string', 'allowed': PRECISIONS},
    'codecase': {'type': 'string', 'empty': False},  # ??
    'producteur': {'type': 'string', 'empty': False},  # ??
}

QUALITE_OBJECT_SCHEMA = {**BASE_OBJECT_SCHEMA,
                         'qualitecat': {'required': True, 'type': 'string', 'allowed': ['01', '02', '03']},
                         }

RTS_LAYER_SCHEMAS = {
    'SIGTA': {**BASE_OBJECT_SCHEMA,
              'altitude_z': {'required': True, 'type': 'number', 'coerce': float},
              'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_TOPO_POINT_LEVE_P']},
              },

    'SIGTO': {**BASE_OBJECT_SCHEMA,
              'altitude_z': {'required': True, 'type': 'number', 'coerce': float},
              'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_TOPO_POINT_CANEVAS_P']},
              'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['YP_1521']},
              },

    'BATIM_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['02', '03']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_ESCALIER_MARCHE_L',
                                                                             'PCRS_BATI_FACADES_L',
                                                                             'PCRS_BATI_PROEMINENCE_L',
                                                                             'PCRS_BATI_SEUIL_L',
                                                                             'PCRS_BATI_PROEMINENCE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['RL_1101']},
                },

    'VOIRI_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['03', '07']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_VOIRIE_REVET_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['LL_0821']},
                },


    'OUVRA_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['03', '07']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_OUV_QUAI_L',
                                                                             'PCRS_OUV_PILE_PONT_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['XL_1341']},
                },

    'VOIEF_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['04']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_FERROVIAIRE_RAIL_L',
                                                                             'PCRS_RAIL_QUAI_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['PL_0981']},
                },

    'CLOTU_L': {**QUALITE_OBJECT_SCHEMA,
                'typemur': {'required': True, 'type': 'string', 'allowed': ['01', '02', '03', '04', '05', '06', '99']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['05']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_CLOTURE_MUR_L',
                                                                             'PCRS_CLOTURE_PILIER_S',
                                                                             'PCRS_CLOTURE_SEUIL_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['SL_1141']},
                },

    'CLOTU_P': {**QUALITE_OBJECT_SCHEMA,
                'section': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['05']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_CLOTURE_PILIER_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['SP_1164']},
                },

    'JARDI_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['06']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['TL_1183']},
                },

    'JARDI_P': {**QUALITE_OBJECT_SCHEMA,
                'reference': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['06']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_VEGET_ARBRE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['TP_1202']},
                },

    'NIVEL_L': {**QUALITE_OBJECT_SCHEMA,
                'reference': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['09']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['OL_0941']},
                },


    'PCRS_AFFLEURANT_P': {**QUALITE_OBJECT_SCHEMA,
                          'nature': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03', '04', '05', '06', '07']},
                          'reseau': {'required': True, 'type': 'string', 'allowed': ['SSAEU',
                                                                                     'ASSARU',
                                                                                     'ASSA',
                                                                                     'AEP',
                                                                                     'ELECECL',
                                                                                     'ELEC',
                                                                                     'GAZ',
                                                                                     'MULT',
                                                                                     'ELECSLT',
                                                                                     'COM',
                                                                                     'ASSAEP',
                                                                                     'DECH',
                                                                                     'INCE',
                                                                                     'CHIM',
                                                                                     'CHAU',
                                                                                     '00']},
                          'thematique': {'required': True, 'type': 'string', 'allowed': ['10']},
                          'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_AFFLEURANT_P']}
                          },


    'PCRS_AFFLEURANT_E': {**QUALITE_OBJECT_SCHEMA,
                          'nature': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03', '04', '05', '06', '07']},
                          'reseau': {'required': True, 'type': 'string', 'allowed': ['SSAEU',
                                                                                     'ASSARU',
                                                                                     'ASSA',
                                                                                     'AEP',
                                                                                     'ELECECL',
                                                                                     'ELEC',
                                                                                     'GAZ',
                                                                                     'MULT',
                                                                                     'ELECSLT',
                                                                                     'COM',
                                                                                     'ASSAEP',
                                                                                     'DECH',
                                                                                     'INCE',
                                                                                     'CHIM',
                                                                                     'CHAU',
                                                                                     '00']},
                          'thematique': {'required': True, 'type': 'string', 'allowed': ['10']},
                          'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_AFFLEURANT_E']}
                          },
}

RTGE_LAYER_SCHEMAS = {
    'SIGTA': {**BASE_OBJECT_SCHEMA,
              'altitude_z': {'required': True, 'min': 0.0},
              'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_TOPO_POINT_LEVE_P']},
              },

    'SIGTO': {**BASE_OBJECT_SCHEMA,
              'altitude_z': {'required': True, 'min': 0.0},
              'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_TOPO_POINT_CANEVAS_P']},
              'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['YP_1521']},
              },

    'BATIM_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['02', '03']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_ESCALIER_MARCHE_L',
                                                                             'PCRS_BATI_FACADES_L',
                                                                             'PCRS_BATI_PROEMINENCE_L',
                                                                             'PCRS_BATI_SEUIL_L',
                                                                             'PCRS_BATI_PROEMINENCE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['RL_1101',
                                                                               'RL_1109',
                                                                               'RL_1110',
                                                                               'RL_1104',
                                                                               'RL_1105',
                                                                               'RL_1106',
                                                                               'RL_1102',
                                                                               'RL_1103']},
                },

    'BATIM_P': {**QUALITE_OBJECT_SCHEMA,
                'section': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['02']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P',
                                                                             'PCRS_CLOTURE_PILIER_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['RP_1121',
                                                                               'RP_1122',
                                                                               'RP_1123',
                                                                               'RP_1124',
                                                                               'RP_1130',
                                                                               'RP_1125',
                                                                               'RP_1126',
                                                                               'RP_1127']},
                },

    'BATIM_E': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['02']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_AFFLEURANT_E']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['RP_1128',
                                                                               'RP_1129']},
                },

    'VOIRI_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['03']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_VOIRIE_REVET_L',
                                                                             'PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['LL_0822',
                                                                               'LL_0824',
                                                                               'LL_0827',
                                                                               'LL_0829',
                                                                               'LL_0821',
                                                                               'LL_0825',
                                                                               'LL_0826',
                                                                               'LL_0828',
                                                                               'LL_0830']},
                },

    'VOIRI_E': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['03']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_E']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['LL_0823']},
                },


    'VOIRI_P': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['03']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['LP_0841',
                                                                               'LP_0842',
                                                                               'LP_0843',
                                                                               'LP_0844']},
                },

    'OUVRA_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['03', '07']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_OUV_QUAI_L',
                                                                             'PCRS_OUV_PILE_PONT_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['XL_1341',
                                                                               'XL_1342',
                                                                               'XL_1343',
                                                                               'XL_1344',
                                                                               'XL_1345',
                                                                               'XL_1346',
                                                                               'XL_1347']},
                },

    'OUVRA_P': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['07']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['XP_1361',
                                                                               'XP_1362',
                                                                               'XP_1363']},
                },

    'VOIEF_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['04']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_FERROVIAIRE_RAIL_L',
                                                                             'PCRS_RAIL_QUAI_L',
                                                                             'PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['PL_0981',
                                                                               'PL_0982',
                                                                               'PL_0983',
                                                                               'PL_0984']},
                },

    'VOIEF_P': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['04']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['PP_1001']},
                },

    'CLOTU_L': {**QUALITE_OBJECT_SCHEMA,
                'typemur': {'required': True, 'type': 'string', 'allowed': ['01', '02', '03', '04', '05', '06', '99']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['05']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_CLOTURE_MUR_L',
                                                                             'PCRS_CLOTURE_PILIER_S',
                                                                             'PCRS_CLOTURE_SEUIL_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['SL_1141']},
                },

    'CLOTU_P': {**QUALITE_OBJECT_SCHEMA,
                'section': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['05']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_CLOTURE_PILIER_P',
                                                                             'PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['SP_1161',
                                                                               'SP_1162',
                                                                               'SP_1163',
                                                                               'SP_1164']},
                },

    'JARDI_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['06']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['TL_1181',
                                                                               'TL_1182',
                                                                               'TL_1183',
                                                                               'TL_1184',
                                                                               'TL_1185']},
                },

    'JARDI_P': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['06']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_VEGET_ARBRE_P',
                                                                             'PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['TP_1201',
                                                                               'TP_1202',
                                                                               'TP_1203',
                                                                               'TP_1204',
                                                                               'TP_1205',
                                                                               'TP_1206',
                                                                               'TP_1207',
                                                                               'TP_1208',
                                                                               'TP_1209']},
                },

    'HYDRO_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['08']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['WL_1301',
                                                                               'WL_1302',
                                                                               'WL_1303',
                                                                               'WL_1304',
                                                                               'WL_1305',
                                                                               'WL_1306',
                                                                               'WL_1307']},
                },

    'MOBUR_P': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['12']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['NP_0921',
                                                                               'NP_0922',
                                                                               'NP_0923',
                                                                               'NP_0924',
                                                                               'NP_0925',
                                                                               'NP_0926',
                                                                               'NP_0927',
                                                                               'NP_0928',
                                                                               'NP_0929',
                                                                               'NP_0930',
                                                                               'NP_0931',
                                                                               'NP_0932',
                                                                               'NP_0933',
                                                                               'NP_0934',
                                                                               'NP_0935',
                                                                               'NP_0936']},
                },

    'MOBUR_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['12']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['NL_0901',
                                                                               'NL_0902']},
                },

    'SCS_NIVEL': {**QUALITE_OBJECT_SCHEMA,
                  'thematique': {'required': True, 'type': 'string', 'allowed': ['13']},
                  'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P']},
                  'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['OP_0961',
                                                                                 'OP_0962']},
                  },

    'NIVEL_L': {**QUALITE_OBJECT_SCHEMA,
                'reference': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02']},
                'thematique': {'required': True, 'type': 'string', 'allowed': ['09']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['OL_0941',
                                                                               'OL_0942',
                                                                               'OL_0943']},
                },

    'TRANS_P': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['14']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['QP_1041',
                                                                               'QP_1042',
                                                                               'QP_1043']},
                },

    'TRANS_E': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['14']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_AFFLEURANT_E']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['QP_1044',
                                                                               'QP_1045']},
                },


    'TRANS_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['14']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['QL_1021',
                                                                               'QL_1022']},
                },

    'AMENA_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['15']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['UL_1221',
                                                                               'UL_1222',
                                                                               'UL_1223']},
                },

    'PROPR_P': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['16']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_P']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['VP_1281',
                                                                               'VP_1282']},
                },

    'PROPR_L': {**QUALITE_OBJECT_SCHEMA,
                'thematique': {'required': True, 'type': 'string', 'allowed': ['16']},
                'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_HABILLAGE_L']},
                'rep_dwg_ge': {'required': True, 'type': 'string', 'allowed': ['VL_1261',
                                                                               'VL_1262',
                                                                               'VL_1263',
                                                                               'VL_1264']},
                },

    'PCRS_AFFLEURANT_P': {**QUALITE_OBJECT_SCHEMA,
                          'nature': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03', '04', '05', '06', '07']},
                          'reseau': {'required': True, 'type': 'string', 'allowed': ['SSAEU',
                                                                                     'ASSARU',
                                                                                     'ASSA',
                                                                                     'AEP',
                                                                                     'ELECECL',
                                                                                     'ELEC',
                                                                                     'GAZ',
                                                                                     'MULT',
                                                                                     'ELECSLT',
                                                                                     'COM',
                                                                                     'ASSAEP',
                                                                                     'DECH',
                                                                                     'INCE',
                                                                                     'CHIM',
                                                                                     'CHAU',
                                                                                     '00']},
                          'thematique': {'required': True, 'type': 'string', 'allowed': ['10']},
                          'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_AFFLEURANT_P']}
                          },


    'PCRS_AFFLEURANT_E': {**QUALITE_OBJECT_SCHEMA,
                          'nature': {'required': True, 'type': 'string', 'allowed': ['00', '01', '02', '03', '04', '05', '06', '07']},
                          'reseau': {'required': True, 'type': 'string', 'allowed': ['SSAEU',
                                                                                     'ASSARU',
                                                                                     'ASSA',
                                                                                     'AEP',
                                                                                     'ELECECL',
                                                                                     'ELEC',
                                                                                     'GAZ',
                                                                                     'MULT',
                                                                                     'ELECSLT',
                                                                                     'COM',
                                                                                     'ASSAEP',
                                                                                     'DECH',
                                                                                     'INCE',
                                                                                     'CHIM',
                                                                                     'CHAU',
                                                                                     '00']},
                          'thematique': {'required': True, 'type': 'string', 'allowed': ['10']},
                          'ref_cnig': {'required': True, 'type': 'string', 'allowed': ['PCRS_AFFLEURANT_E']}
                          },
}
